## -*-Tcl-*-
 # ###################################################################
 #  Vince's Additions - an extension package for Alpha
 # 
 #  FILE: "EnhancedTkcon.tcl"
 #                                    created: 03/23/2001 {21:25:36 PM} 
 #                                last update: 11/22/2001 {13:43:24 PM} 
 #  Author: Vince Darley
 #  E-mail: <vince@santafe.edu>
 #    mail: 317 Paseo de Peralta, Santa Fe, NM 87501
 #     www: <http://www.santafe.edu/~vince/>
 #  
 # Copyright (c) 1997-2001  Vince Darley
 # 
 # See the file "license.terms" for information on usage and redistribution
 # of this file, and for a DISCLAIMER OF ALL WARRANTIES.
 # 
 # Distributable under Tcl-style (free) license.
 #  
 # ###################################################################
 ##

# mode declaration
alpha::extension Tkcon 0.1 {
    alpha::package require AlphaTcl 7.2.1
    menu::replaceWith Utils "<S/Y<Oshell" items "<S/Y<Oshell" "enhancedTkcon" 
} maintainer {
    {Vince Darley} <vince@santafe.edu> <http://www.santafe.edu/~vince/>
} uninstall {this-file} help {Run the 'tkcon' package as a console}

#  Tkcon  #

proc enhancedTkcon {} {
    status::msg "Loading tkcon..."
    global HOME embed_args
    # Do this so tkcon doesn't override unknown.
    set embed_args 1
    uplevel \#0 [list source [file join $HOME Tools tkcon.tcl]]
    unset embed_args
    status::msg "Tkcon loaded"
}


